#!/usr/bin/env node
"use strict";
/**
 * rename-package
 * Rename an internal package
 */
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path = __importStar(require("path"));
const t = __importStar(require("io-ts"));
const A = __importStar(require("fp-ts/Array"));
const E = __importStar(require("fp-ts/Either"));
const O = __importStar(require("fp-ts/Option"));
const R = __importStar(require("fp-ts/Record"));
const T = __importStar(require("fp-ts/These"));
const NEA = __importStar(require("fp-ts/NonEmptyArray"));
const F = __importStar(require("fluture"));
const D = __importStar(require("io-ts-docopt"));
const PathReporter_1 = require("io-ts/lib/PathReporter");
const function_1 = require("fp-ts/function");
const io_ts_docopt_1 = require("io-ts-docopt");
const trace_1 = require("@strong-roots-capital/trace");
const PackageJsonDependencies_1 = require("@typescript-tools/io-ts/dist/lib/PackageJsonDependencies");
const PackageName_1 = require("@typescript-tools/io-ts/dist/lib/PackageName");
const lerna_utils_1 = require("@typescript-tools/lerna-utils");
const package_manifests_1 = require("@typescript-tools/package-manifests");
const stringify_json_1 = require("@typescript-tools/stringify-json");
const debug_1 = __importDefault(require("debug"));
const fast_deep_equal_1 = __importDefault(require("fast-deep-equal"));
// DISCUSS: do we get alphabetical ordering of imports for free? or
// do we need to add that explicitly. I think I saw it
const debug = {
    cmd: debug_1.default('rename')
};
const docstring = `
Usage:
    rename-package --root=<dir> <current-package-name> <desired-package-name>

Options:
    --root=<dir>              Monorepo root directory
    <current-package-name>    Current name (including scope) of target package
    <desired-package-name>    Desired name (including scope) of target package
`;
const CommandLineOptions = io_ts_docopt_1.withEncode(t.intersection([
    t.type({
        '<current-package-name>': t.string,
        '<desired-package-name>': t.string,
    }),
    t.partial({
        '<dir>': t.string,
    }),
]), a => ({
    root: O.fromNullable(a['<dir>']),
    current: a['<current-package-name>'],
    desired: a['<desired-package-name>'],
}));
// Allows for the widening of a particular error into the Err type
const err = (error) => error;
const decodeDocopt = (codec, docstring) => function_1.pipe(D.decodeDocopt(codec, docstring), E.mapLeft((err) => ({ type: 'docopt decode', err: PathReporter_1.PathReporter.report(E.left(err)).join('\n') })), E.map(options => F.resolve(options)), E.getOrElse(err => F.reject(err)));
const stringifyJSON = function_1.flow(stringify_json_1.stringifyJSON(E.toError), E.mapLeft((err) => ({ type: 'unable to stringify package.json', err })));
const write = (file) => (contents) => lerna_utils_1.writeFile(file)(contents)
    .pipe(F.mapRej((err) => ({ type: 'unable to write package.json', err })));
function main() {
    const hasDependency = (dependencyGroup, dependency) => function_1.pipe(O.fromNullable(dependencyGroup), O.chain(R.lookup(dependency)), O.fold(function_1.constFalse, function_1.constTrue));
    const PackageJson = t.intersection([
        t.type({ name: PackageName_1.PackageName }),
        PackageJsonDependencies_1.PackageJsonDependencies,
    ]);
    decodeDocopt(CommandLineOptions, docstring)
        .pipe(F.chain(options => package_manifests_1.packageManifests(O.toUndefined(options.root))
        .pipe(F.chain(packages => {
        const replaceDependency = (dependencies) => function_1.pipe(O.fromNullable(dependencies), O.map(R.reduceWithIndex({}, (name, acc, version) => Object.assign(acc, { [name.replace(RegExp(`^${options.current}$`), options.desired)]: version }))), O.toUndefined);
        return function_1.pipe(packages, A.map(({ pkg, contents }) => function_1.pipe(PackageJson.decode(contents), E.mapLeft(errors => err({ type: 'unable to parse package.json', err: PathReporter_1.PathReporter.report(E.left(errors)).join('\n') })), E.map(contents => ({ pkg, contents })))), function_1.flow(A.separate, ({ left, right }) => T.both(left, right), T.mapLeft(A.map(err => F.resolve(E.left(err))))), T.map(A.filter(
        // DISCUSS: this isn't strictly necessary, is it?
        ({ contents }) => contents.name === options.current
            || hasDependency(contents.dependencies, options.current)
            || hasDependency(contents.devDependencies, options.current)
            || hasDependency(contents.peerDependencies, options.current)
            || hasDependency(contents.optionalDependencies, options.current))), T.map(A.chain(({ pkg, contents }) => {
            const updated = Object.assign(Object.assign({}, contents), { name: contents.name.replace(RegExp(`^${options.current}$`), options.desired), dependencies: replaceDependency(contents.dependencies), devDependencies: replaceDependency(contents.devDependencies), peerDependencies: replaceDependency(contents.peerDependencies), optionalDependencies: replaceDependency(contents.optionalDependencies) });
            return fast_deep_equal_1.default(contents, updated)
                ? []
                : [{ pkg, contents: updated }];
        })), T.map(A.map(({ pkg, contents }) => function_1.pipe(stringifyJSON(contents), E.map(trace_1.trace(debug.cmd, `Writing ${path.resolve(pkg.location, 'package.json')}`)), E.map(write(path.resolve(pkg.location, 'package.json'))), E.getOrElseW(F.reject), future => F.coalesce(e => E.left(e))(a => E.right(a))(future), value => value))), function_1.flow(T.toTuple([], []), A.chain(function_1.identity), F.parallel(250)));
    }))))
        .pipe(F.chainRej(decodeError => F.resolve([E.left(decodeError)])))
        .pipe(F.fork((error) => (console.error('Impossible', error), process.exit(1)))(function_1.flow(A.lefts, NEA.fromArray, O.map(failures => (console.log('Encountered errors:', failures),
        process.exit(1))))));
}
main();
// Local Variables:
// mode: typescript
// End:
//# sourceMappingURL=rename-package.js.map